/* fredtcl.c - tcl-based DUA */

#ifndef	lint
static char *rcsid = "$Header$";
#endif

/*
 * $Header$
 *
 *
 * $Log$
 */

/*				 NOTICE
 *
 *    Acquisition, use, and distribution of this module and related
 *    materials are subject to the restrictions of a license agreement.
 *    Consult the Preface in the User's Manual for the full terms of
 *    this agreement.
 */


#include <ctype.h>
#include <signal.h>
#include <stdio.h>
#include <varargs.h>

#include <isode/internet.h>
#include <isode/sys.file.h>
#include <sys/stat.h>
#include <isode/tailor.h>

#include <tk.h>

/*    DATA */

/* MAIN */

static	char   *myname = "fredtcl";

static	int	approxmatch = 1;
#ifndef	sparc
static	char   *audio = NULLCP;
#else
static	char   *audio= "raw2audio < %s | play &";
#endif
static	char   *calldsa = NULLCP;
	int	debug = 0;
static	char   *display = NULLCP;
static	int	exhaustive = 0;
static	int	fullistings = 0;
static	char   *geometry = NULLCP;
static	char   *jpeg = "xv %s &";
static	int	phone = 0;
static	char   *photo = "xv %s &";
static	char   *server = "internal";
static	int	synchronize = 0;
static	char   *tclfile = NULLCP;
static	int	verbose = 0;
static	int	watch = 0;
static	int	wildmatch = 1;
static	char   *wishfile = "wish.tcl";

static	Tk_ArgvInfo tclArgv[] = {
    { "-approx",	TK_ARGV_CONSTANT, (char *) 1,	(char *) &approxmatch,
	"Use approximate matching when searching" },
    { "-noapprox",	TK_ARGV_CONSTANT, (char *) 0,	(char *) &approxmatch,
	"Don't ..." },
    { "-audio",		TK_ARGV_STRING,   NULLCP,	(char *) &audio,
	"Command to render audio" },
    { "-call",		TK_ARGV_STRING,   NULLCP,	(char *) &calldsa,
	"Name or address of DSA" },
    { "-debug",		TK_ARGV_CONSTANT, (char *) 1,	(char *) &debug,
	"Use debug mode" },
    { "-nodebug",	TK_ARGV_CONSTANT, (char *) 0,	(char *) &debug,
	"Don't ..." },
    { "-display",	TK_ARGV_STRING,   NULLCP,	(char *) &display,
	"Name of X display" },
    { "-exhaustive",	TK_ARGV_CONSTANT, (char *) 1,	(char *) &exhaustive,
	"Exhaustively look for children when browsing" },
    { "-noexhaustive",	TK_ARGV_CONSTANT, (char *) 0,	(char *) &exhaustive,
	"Don't ..." },
    { "-file",		TK_ARGV_STRING,   NULLCP,	(char *) &tclfile,
	"Pathname of commands file" },
    { "-fullistings",	TK_ARGV_CONSTANT, (char *) 1,	(char *) &fullistings,
	"Display all children when browsing" },
    { "-geometry",	TK_ARGV_STRING,   NULLCP,	(char *) &geometry,
	"Inital geometry for window" },
    { "-jpeg",		TK_ARGV_STRING,   NULLCP,	(char *) &jpeg,
	"Command to render JPEG" },
    { "-mail",		TK_ARGV_CONSTANT, (char *) 0,	(char *) &phone,
	"Display mailbox instead of phone number first" },
    { "-partialistings",TK_ARGV_CONSTANT, (char *) 0,	(char *) &fullistings,
	"Display only \"interesting\" children when listing" },
    { "-phone",		TK_ARGV_CONSTANT, (char *) 1,	(char *) &phone,
	"Display phone number instead of mailbox first" },
    { "-photo",		TK_ARGV_STRING,   NULLCP,	(char *) &photo,
	"Command to render PBM" },
    { "-server",	TK_ARGV_STRING,   NULLCP,	(char *) &server,
	"Name or address of DA server" },
    { "-sync",		TK_ARGV_CONSTANT, (char *) 1,	(char *) &synchronize,
	"Use synchronous mode for display server" },
    { "-nosync",	TK_ARGV_CONSTANT, (char *) 0,	(char *) &synchronize,
	"Don't ..." },
    { "-verbose",	TK_ARGV_CONSTANT, (char *) 1,	(char *) &verbose,
	"Use verbose mode" },
    { "-noverbose",	TK_ARGV_CONSTANT, (char *) 0,	(char *) &verbose,
	"Don't ..." },
    { "-watch",		TK_ARGV_CONSTANT, (char *) 1,	(char *) &watch,
	"Use watch mode" },
    { "-nowatch",	TK_ARGV_CONSTANT, (char *) 0,	(char *) &watch,
	"Don't ..." },
    { "-wild",		TK_ARGV_CONSTANT, (char *) 1,	(char *) &wildmatch,
	"Use wildcard matching when searching" },
    { "-nowild",	TK_ARGV_CONSTANT, (char *) 0,	(char *) &wildmatch,
	"Don't ..." },
    { "-wishfile",	TK_ARGV_STRING,   NULLCP,	(char *) &wishfile,
	"Pathname of TK initialization file" },
    { NULLCP,		TK_ARGV_END,	  NULLCP,	NULLCP,	 NULLCP }
};



/* TCL */

static struct dsp {
    char   *d_name;
    IFP	    d_value;
};

static	int	tclready = 0;
static	int	tcltty = 0;

static	Tcl_CmdBuf  tclBuffer;
static	Tcl_Interp *tclInterp;
static	Tk_Window   tclWindow;


void	tclinit ();
int	tcleval ();


extern	Tcl_CmdProc BusyCmd;


/* DISH */

static	int	boundP = 0;
static	int	dish_running = NOTOK;
static	int	interrupted = 0;


struct tmpfile {
    struct tmpfile *t_next;

    char    *t_name;

    char    *t_attr;
    char    *t_ufn;
    char    *t_dn;
};

static	struct tmpfile *tmpfiles = NULL;


/* DA */

static struct sockaddr_in sin;

static int	dafd = NOTOK;
static char	da_reply[BUFSIZ];


#ifndef	lint
static int  da_command (), _da_command ();
#endif
static int  da_response ();


/* ERRORS */

void	adios (), advise ();



/* LIBC */

extern	int	errno;


/*    MAIN */

/* ARGSUSED */

main (argc, argv, envp)
int	argc;
char  **argv,
      **envp;
{
    if (myname = rindex (*argv, '/'))
	myname++;
    if (myname == NULL || *myname == NULL)
	myname = *argv;

    _tailor_logging_only = 1;
    isodetailor (myname, 1);

    if (tcltty = isatty (fileno (stdin)))
	verbose++;

    if (Tk_ParseArgv (tclInterp = Tcl_CreateInterp (), (Tk_Window) 0,
		      &argc, argv, tclArgv, TK_ARGV_NO_LEFTOVERS) != TCL_OK)
	adios (NULLCP, "%s", tclInterp -> result);

    tclinit (argc, argv);

    tclready = 1;
    Tk_MainLoop ();

    (void) CallbackQuit (((Tk_Window) 0), tclInterp, 0, NULLVP);
    /* NOTREACHED */
}

/*    TCL */

/* ARGSUSED */

static void  StructureProc (clientData, eventPtr)
ClientData	clientData;
XEvent	       *eventPtr;
{
    if (eventPtr -> type == DestroyNotify)
	tclWindow = NULL;
}


/* ARGSUSED */

static void  DelayedMap (clientData)
ClientData	clientData;
{
    while (Tk_DoOneEvent (TK_IDLE_EVENTS))
	continue;
    if (tclWindow)
	Tk_MapWindow (tclWindow);
}


/* ARGSUSED */

static void  StdinProc (clientData, mask)
ClientData	clientData;
int		mask;
{
    int	    result;
    char   *cmd,
	    buffer[BUFSIZ];
    static int gotPartial = 0;

    if (mask & TK_READABLE) {
	if (fgets (buffer, sizeof buffer, stdin) == NULL) {
	    if (!gotPartial) {
		if (tcltty)
		    (void) CallbackQuit (((Tk_Window) 0), tclInterp, 0,
					 NULLVP);
		else
		    Tk_DeleteFileHandler (fileno (stdin));

		return;
	    } else
		buffer[0] = NULL;
	}
	if (gotPartial = !(cmd = Tcl_AssembleCmd (tclBuffer, buffer)))
	    return;

	result = Tcl_RecordAndEval (tclInterp, cmd, 0);
	if (*tclInterp -> result && (result != TCL_OK || tcltty))
	    printf ("%s\n", tclInterp -> result);

	if (tcltty) {
	    printf ("%s: ", myname);
	    fflush (stdout);
	}
    }
}

/*  */

struct pair {
    char   *p_name;
    int	   *p_value;

    char   *p_widget;
};

static struct pair bool_pairs[] = {
    "approx",	&approxmatch,	"set %s %d",
    "debug",	&debug,		"set %s %d",
    "exhaustive", &exhaustive,	"set %s %d",
    "fullistings", &fullistings,"set %s %d",
    "phone",	&phone,		"set %s %d",
    "verbose",	&verbose,	"set %s %d",
    "watch",	&watch,		"set %s %d",
    "wild",   	&wildmatch,	"set %s %d",

    NULL
};

/* ARGSUSED */

static int  CallbackBoolean (window, interp, argc, argv)
Tk_Window	window;
Tcl_Interp     *interp;
int		argc;
char	      **argv;
{
    register char  *var;
    char    buffer[BUFSIZ];
    register struct pair *p;

    if (!tclready)
	return TCL_OK;

    if (argc < 2 || argc > 3) {
	(void) sprintf (buffer, "argc=%d; expecting 2 or 3", argc);
	goto tcl_error;
    }

    var = argv[1];
    for (p = bool_pairs; p -> p_name; p++)
	if (strcmp (p -> p_name, var) == 0) {
	    if (argc == 2)
		*p -> p_value = !(*p -> p_value);
	    else
		*p -> p_value = atoi (argv[2]);
	    if (debug)
		fprintf (stderr, "---> set %s %s\n", p -> p_name,
			 *p -> p_value ? "on" : "off");
	    return TCL_OK;
	}

    (void) sprintf (buffer, "expecting a variable, not \"%s\"", argv[1]);
tcl_error: ;
    Tcl_SetResult (interp, buffer, TCL_VOLATILE);
    return TCL_ERROR;
}

/*  */

/* ARGSUSED */

static int  CallbackQuit (window, interp, argc, argv)
Tk_Window	window;
Tcl_Interp     *interp;
int		argc;
char	      **argv;
{
    register struct tmpfile *t,
			    *t2;

    (void) f_unbind ();

    for (t = tmpfiles; t; t = t2) {
	t2 = t -> t_next;

	(void) unlink (t -> t_name);
	free (t -> t_name);

	free (t -> t_attr);

	free ((char *) t);
    }

    Tcl_DeleteInterp (tclInterp);
    if (tclBuffer)
	Tcl_DeleteCmdBuf (tclBuffer);

    exit (0);
    /* NOTREACHED */
}

/*  */

/* ARGSUSED */

static int  DISHcommand (window, interp, argc, argv)
Tk_Window	window;
Tcl_Interp     *interp;
int		argc;
char	      **argv;
{
    register char *cp;
    char   *dp,
	   *ep;
    char    buffer[BUFSIZ];

    if (argc < 2) {
	Tcl_SetResult (interp, "not enough arguments", TCL_STATIC);
	return TCL_ERROR;
    }
    argc--, argv++;

    for (cp = buffer, ep = ""; dp = *argv++; cp += strlen (cp), ep = " ")
	if (index (dp, ' '))
	    (void) sprintf (cp, "%s\"%s\"", ep, dp);
	else
	    (void) sprintf (cp, "%s%s", ep, dp);

    (void) dish (buffer, 0);

    return TCL_OK;
}

/*  */

int	NAMEdirective (), SEARCHdirective (), SORTdirective ();

static struct dsp FREDdsp[] = {
    "name",	NAMEdirective,
    "search",	SEARCHdirective,
    "sort",	SORTdirective,

    NULL
};

static int  FREDcommand (window, interp, argc, argv)
Tk_Window	window;
Tcl_Interp     *interp;
int		argc;
char	      **argv;
{
    register char *cp;
    char    buffer[BUFSIZ];
    register struct dsp *d;

    if (argc < 2) {
	Tcl_SetResult (interp, "not enough arguments", TCL_STATIC);
	return TCL_ERROR;
    }
    argc--, argv++;

    cp = *argv;
    for (d = FREDdsp; d -> d_name; d++)
	if (strcmp (d -> d_name, cp) == 0)
	    return (*d -> d_value) (window, interp, argc, argv);

    (void) sprintf (buffer, "expecting a directive, not  \"%s\"", cp);
    Tcl_SetResult (interp, buffer, TCL_VOLATILE);
    return TCL_ERROR;
}

/*  */

/* ARGSUSED */

static int  BELLcommand (window, interp, argc, argv)
Tk_Window	window;
Tcl_Interp     *interp;
int		argc;
char	      **argv;
{
    int	    number;
    char    buffer[BUFSIZ];

    if (argc != 2) {
	(void) sprintf (buffer, "argc=%d; expecting 2", argc);
	goto tcl_error;
    }

    if (sscanf (argv[1], "%d", &number) != 1) {
	(void) sprintf (buffer, "argv[2]=\"%s\"; expecting an integer",
			argv[2]);
	goto tcl_error;
    }
    if (number < 100 || number > 100) {
	(void) sprintf (buffer, "argument must be between -100..+100");
	goto tcl_error;
    }

    (void) XBell (Tk_Display (tclWindow), number);
    return TCL_OK;

tcl_error: ;
    Tcl_SetResult (interp, buffer, TCL_VOLATILE);
    return TCL_ERROR;
}

/*  */

#ifdef	BSDSIGS
/* ARGSUSED */
#endif

static SFD  intrser (sig)
int	sig;
{
#ifndef	BSDSIGS
    (void) signal (sig, intrser);
#endif

    (void) CallbackQuit (((Tk_Window) 0), tclInterp, 0, NULLVP);
}

/*  */

static void  tclinit (argc, argv)
int	argc;
char  **argv;
{
    char   *args,
	    buffer[BUFSIZ],
	    file[BUFSIZ];
    register struct pair *p;
    Tk_3DBorder border;

    if ((tclWindow = Tk_CreateMainWindow (tclInterp, display, myname)) == NULL)
	adios (NULLCP, "%s", tclInterp -> result);
    Tk_SetClass (tclWindow, "FREDTCL");
    Tk_CreateEventHandler (tclWindow, StructureNotifyMask, StructureProc,
			   (ClientData) 0);
    Tk_DoWhenIdle (DelayedMap, (ClientData) 0);

    args = Tcl_Merge (argc - 1, argv + 1);
    (void) Tcl_SetVar (tclInterp, "argv", args, TCL_GLOBAL_ONLY);
    free (args);
    (void) sprintf (args = buffer, "%d", argc - 1);
    (void) Tcl_SetVar (tclInterp, "argc", args, TCL_GLOBAL_ONLY);

    if (synchronize)
	XSynchronize (Tk_Display (tclWindow), True);
    Tk_GeometryRequest (tclWindow, 200, 200);
    if (border = Tk_Get3DBorder (tclInterp, tclWindow, None, "#4eee94"))
	Tk_SetBackgroundFromBorder (tclWindow, border);
    else {
	Tcl_ResetResult (tclInterp);
	Tk_SetWindowBackground (tclWindow,
				WhitePixelOfScreen (Tk_Screen (tclWindow)));
    }
    XSetForeground (Tk_Display (tclWindow),
		    DefaultGCOfScreen (Tk_Screen (tclWindow)),
		    BlackPixelOfScreen (Tk_Screen (tclWindow)));

    Tcl_CreateCommand (tclInterp, "CallbackBoolean", CallbackBoolean,
		       (ClientData) tclWindow, (void (*) ()) 0);
    Tcl_CreateCommand (tclInterp, "CallbackQuit", CallbackQuit,
		       (ClientData) tclWindow, (void (*) ()) 0);

    Tcl_CreateCommand (tclInterp, "dish", DISHcommand,
		       (ClientData) tclWindow, (void (*) ()) 0);
    Tcl_CreateCommand (tclInterp, "fred", FREDcommand,
		       (ClientData) tclWindow, (void (*) ()) 0);

    Tcl_CreateCommand (tclInterp, "bell", BELLcommand,
		       (ClientData) tclWindow, (void (*) ()) 0);

    Tcl_CreateCommand (tclInterp, "busy", BusyCmd,
		       (ClientData) tclWindow, (void (*) ()) 0);

    if (geometry)
	Tcl_SetVar (tclInterp, "geometry", geometry, TCL_GLOBAL_ONLY);

    (void) sprintf (buffer, *wishfile != '/' ? "source $tk_library/%s"
					     : "source %s", wishfile);
    if (tcleval (tclInterp, buffer, 0, NULLVP) != TCL_OK)
	adios (NULLCP, "you lose");

    (void) sprintf (buffer, "set fred_library \"%s\"", isodefile ("tcl", 0));
    if (tcleval (tclInterp, buffer, 0, NULLVP) != TCL_OK)
	adios (NULLCP, "you lose");

    (void) sprintf (buffer, "set myname %s", myname);
    (void) tcleval (tclInterp, buffer, 0, NULLVP);

    if (tclfile && strcmp (tclfile, "-") == 0) {
	Tk_CreateFileHandler (fileno (stdin), TK_READABLE, StdinProc,
			      (ClientData) 0);
	tclBuffer = Tcl_CreateCmdBuf ();

	tclfile = NULL;
    }
    else
	tclBuffer = NULL;

    if (tclfile == NULL)
	(void) sprintf (file, "%s.tcl", myname);
    else
	(void) strcpy (file, tclfile);
    (void) sprintf (buffer, access (file, R_OK) == NOTOK && *file != '/'
				? "source $fred_library/%s" : "source %s",
		    file);
    if (tcleval (tclInterp, buffer, 0, NULLVP) != TCL_OK)
	adios (NULLCP, "you lose");

    (void) sprintf (buffer, "wm title . %s", myname);
    (void) tcleval (tclInterp, buffer, 0, NULLVP);

    for (p = bool_pairs; p -> p_name; p++) {
	(void) sprintf (buffer, p -> p_widget, p -> p_name, *p -> p_value);
	(void) tcleval (tclInterp, buffer, 0, NULLVP);
    }

    if (verbose) {
	fprintf (stderr, "connecting to Directory service... ");
	(void) fflush (stderr);
    }
    fredinit ();
    if (verbose)
	fprintf (stderr, "\n");

    (void) tcleval (tclInterp, "update", 0, NULLVP);

    (void) signal (SIGINT, intrser);
    (void) signal (SIGQUIT, intrser);

    if (tclBuffer && tcltty) {
	printf ("%s: ", myname);
	fflush (stdout);
    }
}

/*  */

static int  tcleval (interp, str, flags, ptr)
Tcl_Interp *interp;
char   *str;
int	flags;
char  **ptr;
{
    int	    ready,
	    result;
    char   *cp;

    if (debug)
	fprintf (stderr, "<--- [%s]\n", str);
    if ((result = Tcl_Eval (interp, str, flags, ptr)) == TCL_OK)
	return TCL_OK;

    if ((cp = Tcl_GetVar (interp, "errorInfo", TCL_GLOBAL_ONLY)) == NULL)
	cp = interp -> result;
    ready = tclready, tclready = 0;
    advise (NULLCP, "%s: %s", str, cp);
    tclready = ready;

    return result;
}

/*    FRED */

static	fredinit ()
{
    char   *cp,
	   *dp;
    char    buffer[BUFSIZ];

/* could read $QUIPURC (user's .quipurc), but don't need username: */
/* could read isodefile ("fredrc", 0), but don't need areas */

    if (f_bind () == NOTOK)
	adios (NULLCP, "unable to access DA service");

    (void) f_ufnrc ();

/* could read $HOME/.fredrc, but don't really need options */

    if ((cp = getenv ("DISPLAY")) && (dp = index (cp, ':'))) {
	*dp++ = NULL;

	if (strcmp (cp, "local")
	        && strcmp (cp, "localhost")
	        && strcmp (cp, "unix"))
	    (void) sprintf (buffer, "fred -display \"%s:%s\"", cp, dp);
	else {
	    register struct hostent *hp;

	    if (hp = gethostbystring (getlocalhost ()))
		(void) sprintf (buffer, "fred -display \"%s:%s\"",
				inet_ntoa (*((struct in_addr *) hp -> h_addr)),
				dp);
	    else
		buffer[0] = NULL;
	}

	*--dp = ':';

	if (buffer[0])
	    (void) dish (buffer, 1);
    }

    (void) sprintf (cp = buffer, "fred -expand ");
    cp += strlen (cp);
    if (fullistings) {
	(void) sprintf (cp, "-full ");
	cp += strlen (cp);
    }
    if (exhaustive) {
	(void) sprintf (cp, "-exhaustive ");
	cp += strlen (cp);
    }
    (void) sprintf (cp, "@");

    (void) dish (buffer, 0);
}

/*  */

/* ARGSUSED */

static int  NAMEdirective (window, interp, argc, argv)
Tk_Window	window;
Tcl_Interp     *interp;
int		argc;
char	      **argv;
{
    int	    vecp;
    char   *cp,
	   *key,
	    buffer[BUFSIZ],
    	   *vec[NVEC];

    if (argc != 3) {
	(void) sprintf (buffer, "argc=%d; expecting 3", argc);
	goto tcl_error;
    }
    argv++;
    
    key = *argv++;
    if ((vecp = sstr2arg (*argv, NVEC, vec, ",")) == NOTOK) {
	(void) strcpy (buffer, "too many components");
	goto tcl_error;
    }

    if (strcmp (key, "head") == 0) {
	Tcl_SetResult (interp, vec[0], TCL_VOLATILE);
	return TCL_OK;
    }

    if (strcmp (key, "tail") == 0) {
	char   *s = "";

	Tcl_ResetResult (interp);
	if (vecp > 1)
	    for (vecp = 1; cp = vec[vecp++]; s = ", ") {
		(void) sprintf (buffer, "%s\"%s\"", s, cp);
		Tcl_AppendResult (interp, buffer, NULLCP);
	    }
	return TCL_OK;
    }

    (void) sprintf (buffer, "expecting a keyword, not \"%s\"", key);
tcl_error: ;
    Tcl_SetResult (interp, buffer, TCL_VOLATILE);
    return TCL_ERROR;
}

/*  */

/* ARGSUSED */

static int  SEARCHdirective (window, interp, argc, argv)
Tk_Window	window;
Tcl_Interp     *interp;
int		argc;
char	      **argv;
{
    int	    vecp;
    char   *cp,
	   *dp,
	    buffer[BUFSIZ],
    	  **vec,
	  **vp;

    if (argc != 3) {
	(void) sprintf (buffer, "argc=%d; expecting 3", argc);
	Tcl_SetResult (interp, buffer, TCL_VOLATILE);
	return TCL_ERROR;
    }
    argv++;

    if (Tcl_SplitList (interp, *argv++, &vecp, &vec) != TCL_OK)
	return TCL_ERROR;

    (void) strcpy (buffer, "-1");
    for (vp = vec, cp = *argv; dp = *vp; vp++)
	if (lexequ (dp, cp) == 0) {
	    (void) sprintf (buffer, "%d", vp - vec);
	    break;
	}
    Tcl_SetResult (interp, buffer, TCL_VOLATILE);

    free ((char *) vec);
    return TCL_OK;
}

/*  */

static int  compar (a, b)
char **a,
     **b;
{
    return lexequ (*a, *b);
}


/* ARGSUSED */

static int  SORTdirective (window, interp, argc, argv)
Tk_Window	window;
Tcl_Interp     *interp;
int		argc;
char	      **argv;
{
    int	    vecp;
    char    buffer[BUFSIZ],
    	  **vec;

    if (argc != 2) {
	(void) sprintf (buffer, "argc=%d; expecting 2", argc);
	Tcl_SetResult (interp, buffer, TCL_VOLATILE);
	return TCL_ERROR;
    }
    argv++;

    if (Tcl_SplitList (interp, *argv, &vecp, &vec) != TCL_OK)
	return TCL_ERROR;

    qsort ((char *) vec, vecp, sizeof *vec, compar);
    interp -> result = Tcl_Merge (vecp, vec);
    interp -> freeProc = (Tcl_FreeProc *) free;

    free ((char *) vec);
    return TCL_OK;
}

/*    DISH */

static int  dish (command, silent)
char   *command;
int	silent;
{
    int	    result;

    if (tclready)
	(void) tcleval (tclInterp, "mkBusy", 0, NULLVP);

    result = dishaux (command, silent);

    if (tclready)
	(void) tcleval (tclInterp, "notBusy", 0, NULLVP);

    return result;
}

/*  */

static int  dishaux (command, silent)
char   *command;
int	silent;
{
    int	    cc,
	    listing = 0,
	    n,
	    sd,
	    status;
    register char *cp;
    char    c,
	   *fmt,
	    buffer[BUFSIZ],
	    where[BUFSIZ];
    register struct sockaddr_in *sock = &sin;
    static int inprogress = 0;

    if (inprogress) {
	if (debug)
	    fprintf (stderr, "dish already in progress...\n");

	if (tclready)
	    (void) tcleval (tclInterp,
			    "mkMsg \"please finish current operation!\"", 0,
			    NULLVP);

	return OK;
    }
    inprogress = 1;

    if (watch) {
	(void) fprintf (stderr, "%s\n", command);
	(void) fflush (stderr);
    }

    if (dafd != NOTOK) {
	if (da_command ("STAT") == NOTOK) {
	    (void) close_tcp_socket (dafd);
	    dafd = NOTOK, boundP = 0;
	}
    }
    else
	if (dish_running != NOTOK
	        && kill (dish_running, 0) == NOTOK)
	    dish_running = NOTOK, boundP = 0;

    if (dish_running == NOTOK && dafd == NOTOK) {
	int	vecp;
	char	dishname[BUFSIZ],
	       *vec[7];
	static int very_first_time = 1;

	if (very_first_time) {
	    (void) unsetenv ("DISHPROC");
	    (void) unsetenv ("DISHPARENT");

	    very_first_time = 0;
	}

	if (strcmp (server, "internal")) {
	    int	    portno;
	    char   *cp,
		   *dp;
	    register struct hostent *hp;
	    register struct servent *sp;

	    if ((dafd = start_tcp_client ((struct sockaddr_in *) 0, 0))
		    == NOTOK)
		adios ("control connection", "unable to start");

	    if (cp = index (server, ':')) {
		if (sscanf (cp + 1, "%d", &portno) == 1)
		    *cp = NULL;
		else
		    cp = NULL;
	    }
	    if ((hp = gethostbystring (server)) == NULL)
		adios (NULLCP,
		       "%s: unknown host for directory assistance server",
		       server);
	    if (cp)
		*cp = ':';
	    bzero ((char *) sock, sizeof *sock);
	    sock -> sin_family = hp -> h_addrtype;
	    inaddr_copy (hp, sock);

	    if (cp)
		sock -> sin_port = htons ((u_short) portno);
	    else
		if ((sp = getservbyname ("da", "tcp")) == NULL)
		    sock -> sin_port = htons ((u_short) 411);
		else
		    sock -> sin_port = sp -> s_port;

	    if (join_tcp_server (dafd, sock) == NOTOK)
		adios ("control connection", "unable to establish");
	    
	    if (da_response () == NOTOK)
		adios (NULLCP, "%s", da_reply);

	    cp = da_reply + sizeof "+OK " - 1;
	    if ((dp = index (cp, ' ')) == NULLCP
		    || sscanf (dp + 1, "%d", &portno) != 1)
		adios (NULLCP, "malformed response for data connection: %s",
		       da_reply);
	    *dp = NULL;

	    if ((hp = gethostbystring (cp)) == NULL)
		adios (NULLCP, "%s: unknown host for data connection", cp);
	    bzero ((char *) sock, sizeof *sock);
	    sock -> sin_family = hp -> h_addrtype;
	    inaddr_copy (hp, sock);
	    sock -> sin_port = htons ((u_short) portno);

	    boundP = 1;
	    (void) signal (SIGPIPE, SIG_IGN);
	    goto do_conn;
	}

	if (get_dish_sock (sock, getpid (), 1) == NOTOK)
	    exit (1);

	(void) strcpy (dishname, _isodefile (isodebinpath, "dish"));

fork_again: ;
	switch (dish_running = vfork ()) {
	    case NOTOK:
	        adios ("fork", "unable to");
		/* NOT REACHED */

	    case OK:
		vecp = 0;
		vec[vecp++] = "dish";
		vec[vecp++] = "-pipe";
		vec[vecp++] = "-dad";
		vec[vecp++] = "-fast";
		vec[vecp] = NULL;
		(void) execv (dishname, vec);
		(void) fprintf (stderr, "unable to exec ");
		perror (dishname);
		_exit (1);

	    default:
		for (;;) {
		    if ((sd = start_tcp_client ((struct sockaddr_in *) 0, 0))
			    == NOTOK)
			adios ("client", "unable to start");
		    if (join_tcp_server (sd, sock) != NOTOK)
			break;

		    (void) close_tcp_socket (sd);

		    sleep (5);

		    if (kill (dish_running, 0) == NOTOK)
			goto fork_again;
		}

		boundP = 1;
		(void) signal (SIGPIPE, SIG_IGN);
		break;
	}
    }
    else {
do_conn: ;
	if ((sd = start_tcp_client ((struct sockaddr_in *) 0, 0)) == NOTOK)
	    adios ("client", "unable to start");
	if (join_tcp_server (sd, sock) == NOTOK)
	    adios ("server", "unable to join");
    }

    (void) sprintf (buffer, "%s\n", command);
    n = send (sd, buffer, cc = strlen (buffer), 0);
    if (debug)
	(void) fprintf (stderr, "wrote %d of %d octets to DUA\n", n, cc);

    if (tclready)
	(void) tcleval (tclInterp, "mkMsg \"working...\"; update", 0, NULLVP);

    if (n != cc)
	if (n == NOTOK) {
	    advise ("please retry", "write to DUA failed,");
	    goto losing;
	}
	else
	    adios (NULLCP, "write to DUA truncated, sent %d of %d octets",
		   n, cc);

    status = OK;
    for (;;) {
	if (tclready) {
	    int	    nfds;
	    fd_set  rfds;

	    FD_ZERO (&rfds);
	    FD_SET (sd, &rfds);
	    nfds = sd;
	    FD_SET (cc = ConnectionNumber (Tk_Display (tclWindow)), &rfds);
	    if (cc > nfds)
		nfds = cc;

	    switch (xselect (nfds + 1, &rfds, NULLFD, NULLFD, NOTOK)) {
	        case NOTOK:
	            advise ("failed", "xselect");
		    /* and fall... */
		case OK:
		    continue;

		default:
		    if (FD_ISSET (cc, &rfds)
		            && Tk_DoOneEvent (TK_X_EVENTS | TK_DONT_WAIT))
			(void) tcleval (tclInterp, "update", 0, NULLVP);
		    if (!FD_ISSET (sd, &rfds))
			continue;
		    break;
	    }
	}

	if ((cc = recv (sd, buffer, sizeof buffer - 1, 0)) == NOTOK) {
err_recv: ;
	    if (!interrupted)
		adios ("failed", "read from DUA");

	    if (dafd != NOTOK)
		(void) da_command ("INTR");
	    else
		(void) kill (dish_running, SIGINT);
	    interrupted = 0;
	    continue;
	}

	buffer[cc] = NULL;
	if (debug) {
	    (void) fprintf (stderr, "read %d octets from DUA: '%c'\n", cc,
		     cc > 0 ? buffer[0] : ' ');
	}
	if (watch) {
	    if (cp = index (buffer, '\n'))
		*cp = NULL;
	    fprintf (stderr, "%s\n", buffer);
	    if (cp)
		*cp = '\n';
	}
	if (cc == OK) {
lost_dua: ;
	    if ((dafd != NOTOK ? da_command ("STAT") : kill (dish_running, 0))
		    == NOTOK) {
		if (dafd != NOTOK) {
		    (void) close_tcp_socket (dafd);
		    dafd = NOTOK;
		}
		boundP = 0;

		advise (NULLCP, "lost DUA");
	    }
	    else
		if (strncmp (command, "fred -expand ",
			     sizeof "fred -expand " - 1) == 0) {
		    (void) close_tcp_socket (sd);

		    if (tclready)
			(void) tcleval (tclInterp,
					"mkMsg \"no additional information\"",
					0, NULLVP);
		    inprogress = 0;
		    return status;
		}

	    break;
	}

	if (!isdigit (buffer[0])) {
	    register char  *ep;

	    cp = buffer + cc - 1;
	    ep = buffer + sizeof buffer - 1;

	    while (*cp != '\n') {
		++cp;
		switch (cc = recv (sd, cp, ep - cp, 0)) {
		    case NOTOK:
		        goto err_recv;

		    case OK:
		    default:
			if (debug)
			    (void) fprintf (stderr, "read %d more octets from DUA\n",
				     cc);
			if (cc == OK)
			    goto lost_dua;
		        cp += cc - 1;
			if (cp < ep)
			    continue;
			if (debug)
			    (void) fprintf (stderr,
				     "'%c' directive exceeds %d octets",
				     buffer[0], sizeof buffer - 1);
			cp++;
			break;
		}
		break;
	    }
	    *cp = NULL;
	}

	switch (c = buffer[0]) {
	    case '2':
		status = NOTOK;
		/* and fall... */
	    case '1':
	    case '3':
	    case '4':
	    case '5':
		(void) Tcl_UnsetVar (tclInterp, "fredtcl_buffer",
				     TCL_GLOBAL_ONLY);
	        if (cc > 1 && !silent)
		    (void) Tcl_SetVar (tclInterp, "fredtcl_buffer", buffer + 1,
				       TCL_GLOBAL_ONLY | TCL_APPEND_VALUE);
			    
		while ((cc = recv (sd, buffer, sizeof buffer - 1, 0)) > OK)
		    if (!silent) {
			buffer[cc] = NULL;
			(void) Tcl_SetVar (tclInterp, "fredtcl_buffer",
					   buffer,
					   TCL_GLOBAL_ONLY | TCL_APPEND_VALUE);
		    }
		if (!silent) {
		    if (c == '5' || c == '3')
			(void) strcpy (buffer, "mkList");
		    else
			(void) sprintf (buffer, "mkText %c {%s}", c, command);
		    (void) tcleval (tclInterp, buffer, 0, NULLVP);
		    if (c == '3') {
			(void) close_tcp_socket (sd);

			if (tclready)
			    (void) tcleval (tclInterp,
					    "mkMsg \"incomplete information only\"",
					    0,
					    NULLVP);
			inprogress = 0;
			return status;
		    }
		}
		break;

	    case 'l':
		{
		    if (!listing) {
			(void) Tcl_UnsetVar (tclInterp, "fredtcl_buffer",
					     TCL_GLOBAL_ONLY);
			listing = 1;
		    }
		    else
			(void) Tcl_SetVar (tclInterp, "fredtcl_buffer", "\n",
					   TCL_GLOBAL_ONLY | TCL_APPEND_VALUE);

		    (void) Tcl_SetVar (tclInterp, "fredtcl_buffer", buffer + 1,
				       TCL_GLOBAL_ONLY | TCL_APPEND_VALUE);
		    goto stuff_back;
		}

	    case 'L':
		listing = 0;
		(void) sprintf (where,
				"mkMsg \"waiting...\"; mkListing {%s}; mkMsg \"working...\"; update",
				buffer + 1);
		if (tcleval (tclInterp, where, 0, NULLVP) != TCL_OK)
		    (void) strcpy (where, "L");
		else
		    (void) sprintf (where, "L%s",
				    Tcl_GetVar (tclInterp, "fredtcl_buffer",
						TCL_GLOBAL_ONLY));
		goto stuff_it;

	    case 'A':
		fmt = audio;
		goto do_val;

	    case 'J':
		fmt = jpeg;
		goto do_val;

	    case 'P':
		fmt = photo;
do_val: ;
		if (fmt == NULL)
		    goto stuff_back;
		{
		    int	    size;
		    register struct tmpfile *t;
		    FILE   *fp;
		    static int seqno = 0;

		    if (sscanf (buffer + 1, "%d", &size) != 1
			    || (cp = index (buffer + 1, ' ')) == NULL)
			goto stuff_back;

		    (void) sprintf (where, "/tmp/%s%d.XXXXXX", myname,
				    seqno++);
		    (void) unlink (mktemp (where));
		    if ((fp = fopen (where, "w")) == NULL)
			goto stuff_back;

		    if ((t = (struct tmpfile *) calloc (1, sizeof *t)) == NULL
			    || (t -> t_name = strdup (where)) == NULL
			    || (t -> t_attr = strdup (++cp)) == NULL) {
			if (t) {
			    if (t -> t_name)
				free (t -> t_name);
			    free ((char *) t);
			}
			(void) fclose (fp);
			(void) unlink (where);
			goto stuff_back;
		    }
		    t -> t_next = tmpfiles, tmpfiles = t;
		    if (cp = index (t -> t_attr, '$')) {
			*cp++ = NULL;
			if (cp = index (t -> t_ufn = cp, '$')) {
			    *cp++ = NULL;
			    t -> t_dn = cp;
			}
		    }

		    (void) strcpy (where, "y\n");
		    if (watch) {
			(void) fprintf (stderr, "%s", where);
			(void) fflush (stderr);
		    }
		    n = send (sd, where, cc = strlen (where), 0);
		    if (debug)
			(void) fprintf (stderr,
					"wrote %d of %d octets to DUA\n",
					n, cc);
		    if (n != cc)
			if (n == NOTOK)
			    adios ("failed", "write to DUA");
			else
			    adios (NULLCP,
				   "write to DUA truncated, sent %d of %d octets",
				   n, cc);

		    while (size > 0) {
			if ((n = size) > sizeof buffer)
			    n = sizeof buffer;
			switch (cc = recv (sd, buffer, n, 0)) {
			    case NOTOK:
				adios ("failed", "read from DUA");

			    case OK:
				adios (NULLCP, "DA protocol error");

			    default:
			        (void) fwrite (buffer, sizeof *buffer, cc,
					       fp);
				size -= cc;
			}
		    }

		    (void) fclose (fp);

		    (void) sprintf (cp = buffer, "%s$", t -> t_attr);
		    cp += strlen (cp);
		    (void) sprintf (cp, fmt, t -> t_name);
		    (void) Tcl_SetVar (tclInterp, "fredtcl_buffer", buffer,
				       TCL_GLOBAL_ONLY);
		    (void) tcleval (tclInterp, "mkVals", 0, NULLVP);

		    goto stuff_back;
		}

	    case 'D':
	    case 'd':
		(void) Tcl_SetVar (tclInterp, "fredtcl_buffer", buffer + 1,
				       TCL_GLOBAL_ONLY);
		(void) tcleval (tclInterp, c == 'd' ? "mkList" : "mkPtrs", 0,
				NULLVP);
		goto stuff_back;

	    case 'M':
		(void) sprintf (where, "mkMsg {%s}; update", buffer + 1);
		(void) tcleval (tclInterp, where, 0, NULLVP);
		goto stuff_back;

	    case 'm':
		advise (NULLCP, "%s", buffer + 1);
stuff_back: ;
		(void) sprintf (where, "%c", c);
		goto stuff_it;

	    case 'y':
		(void) sprintf (where,
				"mkDialog .modal {-text {%s} -justify left} \
{yes {set fredtcl_buffer y}} {no {set fredtcl_buffer n}} {cancel {set fredtcl_buffer N}}",
				buffer + 1);
		if (tcleval (tclInterp, where, 0, NULLVP) != TCL_OK)
		    (void) strcpy (where, "N");
		else
		    (void) sprintf (where, "%c",
			            *Tcl_GetVar (tclInterp, "fredtcl_buffer",
				    TCL_GLOBAL_ONLY));
stuff_it: ;
		(void) strcat (where, "\n");
		if (watch) {
		    (void) fprintf (stderr, "%s", where);
		    (void) fflush (stderr);
		}
		n = send (sd, where, cc = strlen (where), 0);
		if (debug)
		    (void) fprintf (stderr, "wrote %d of %d octets to DUA\n",
				    n, cc);

		if (n != cc)
		    if (n == NOTOK) {
			advise ("please retry", "write to DUA failed,");
			goto losing;
		    }
		    else
			adios (NULLCP,
			       "write to DUA truncated, sent %d of %d octets",
			       n, cc);
		continue;

	    default:
		advise (NULLCP, "unexpected opcode 0x%x -- contact a camayoc",
			buffer[0]);
		break;
	}
	break;
    }

    (void) close_tcp_socket (sd);

    if (tclready)
        (void) tcleval (tclInterp, "mkMsg \"\"", 0, NULLVP);
    inprogress = 0;
    return status;

losing: ;
    (void) f_unbind ();
    (void) close_tcp_socket (sd);

    if (tclready)
	(void) tcleval (tclInterp, "mkMsg \"\"", 0, NULLVP);
    inprogress = 0;
    return NOTOK;
}

/*  */

/* ARGSUSED */

static int  f_bind ()
{
    char    buffer[BUFSIZ];

    if (boundP)
	return OK;

    if (calldsa)
	(void) sprintf (buffer, "bind -call \"%s\"", calldsa);
    else
	(void) strcpy (buffer, "bind");

    return dish (buffer, 0);
}


static  int  f_unbind ()
{
    if (dafd != NOTOK) {
	(void) da_command ("QUIT");

	(void) close_tcp_socket (dafd);
    }
    else
	if (dish_running != NOTOK)
	    (void) kill (dish_running, SIGHUP);

    dafd = dish_running = NOTOK, boundP = 0;

    return OK;
}


static int  f_ufnrc () {
    register int   i;
    int	    inprogress;
    register char *bp,
		  *cp,
		  *ep;
    char    buffer[BUFSIZ],
	    sync[BUFSIZ],
	    ufnrc[BUFSIZ];
    FILE   *fp;

    if (bp = getenv ("UFNRC"))
	(void) strcpy (ufnrc, bp);
    else {
	if ((bp = getenv ("HOME")) == NULL)
	    bp = ".";

	(void) sprintf (ufnrc, "%s/.ufnrc", bp);
    }

    if ((fp = fopen (ufnrc, "r")) == NULL) {
	(void) strcpy (ufnrc, isodefile ("ufnrc", 0));

	if ((fp = fopen (ufnrc, "r")) == NULL)
	    return NOTOK;
    }

    (void) sprintf (ep = sync, "fred -ufnrc");
    ep += strlen (ep);

    inprogress = 0;
    for (i = 0; fgets (bp = buffer, sizeof buffer, fp); i++) {
	if (*buffer == '#')
	    continue;
	if (bp = index (buffer, '\n'))
	    *bp = NULL;

	bp = buffer;
	if (*bp == NULL) {
	    if (inprogress) {
		(void) strcpy (ep, "\"");
		ep += strlen (ep);
		inprogress = 0;
	    }
	    continue;
	}

	if (!isspace (*bp)) {
	    int	    lower,
		    upper;
	    register char *dp;

	    if ((cp = index (bp, ':')) == NULL) {
		advise (NULLCP, "%s: missing ':' at line %d", ufnrc, i);
		return NOTOK;
	    }
	    *cp++ = NULL;

	    if (dp = index (bp, ',')) {
		*dp++ = NULL;

		while (isspace (*dp))
		    dp++;
		upper = *dp == '+' ? 32767 : atoi (dp);
	    }
	    else
		upper = 0;

	    lower = atoi (bp);
	    (void) sprintf (ep, " %d %d \"", lower, upper ? upper : lower);
	    ep += strlen (ep);

	    bp = cp;
	    inprogress = 1;
	}
	else
	    if (!inprogress) {
		advise (NULLCP, "%s: unexpected blank at start of line %d",
			   ufnrc, i);
		return NOTOK;
	    }
	    else
		*ep++ = '$';

	while (isspace (*bp))
	    bp++;
	(void) sprintf (ep, "%s", bp);
	ep += strlen (ep);
    }

    if (inprogress) {
	(void) strcpy (ep, "\"");
	ep += strlen (ep);
	inprogress = 0;
    }

    (void) fclose (fp);

    return dish (sync, 1);
}

/*    DA */

#ifndef	lint
static int  da_command (va_alist)
va_dcl
{
    int	    val;
    va_list ap;

    va_start (ap);

    val = _da_command (ap);

    va_end (ap);

    return val;
}

static int  _da_command (ap)
va_list ap;
{
    int	    cc,
	    len;
    char    buffer[BUFSIZ];

    if (dafd == NOTOK)
	return NOTOK;

    _asprintf (buffer, NULLCP, ap);
    if (watch) {
	(void) fprintf (stderr, "<--- %s\n", buffer);
	(void) fflush (stderr);
    }

    (void) strcat (buffer, "\r\n");
    len = strlen (buffer);

    if (write_tcp_socket (dafd, buffer, len) != len)
	adios ("failed", "write_tcp_socket to control connection");

    return (da_response ());
}
#else
/* VARARGS1 */

static int  da_command (fmt)
char   *fmt;
{
    return da_command (fmt);
}
#endif

/*  */

static int  da_response ()
{
    register char *cp,
		  *ep;

    for (ep = (cp = da_reply) + sizeof da_reply - 1; cp < ep;) {
	if (read_tcp_socket (dafd, cp, sizeof *cp) != 1)
	    adios ("control connection", "eof or error reading");
	if (*cp++ == '\n')
	    break;
    }
    *cp = NULL;

    if (cp > da_reply)
	cp--;
    if (*cp == '\n') {
	*cp = NULL;
	if (cp > da_reply)
	    cp--;
    }
    if (*cp == '\r')
	*cp = NULL;

    if (watch) {
	(void) fprintf (stderr, "---> %s\n", da_reply);
	(void) fflush (stderr);
    }

    switch (da_reply[0]) {
	case '+':
	    return OK;

	case '-':
	    return NOTOK;

	default:
	    adios (NULLCP, "unrecognized response");
	    /* NOTREACHED */
    }    
}

/*    ERRORS */

#ifndef	lint
void	_advise ();


static void  adios (va_alist)
va_dcl
{
    va_list ap;

    va_start (ap);

    _advise (ap);

    va_end (ap);

    _exit (1);
}
#else
/* VARARGS */

static void  adios (what, fmt)
char   *what,
       *fmt;
{
    adios (what, fmt);
}
#endif


#ifndef	lint
static void  advise (va_alist)
va_dcl
{
    va_list ap;

    va_start (ap);

    _advise (ap);

    va_end (ap);
}


static void  _advise (ap)
va_list	ap;
{
    char    buffer[BUFSIZ];

    asprintf (buffer, ap);

    if (tclready) {
	char dialog[BUFSIZ + sizeof "mkDialog .err \"-text \{%s\}\""];

	(void) sprintf (dialog,     "mkDialog .err \"-text \{%s\}\"",
			buffer);
	if (tcleval (tclInterp, dialog, 0, NULLVP) == TCL_OK)
	    return;
    }

    (void) fflush (stdout);

    fprintf (stderr, "%s: ", myname);
    (void) fputs (buffer, stderr);
    (void) fputc ('\n', stderr);

    (void) fflush (stderr);
}
#else
/* VARARGS */

static void  advise (what, fmt)
char   *what,
       *fmt;
{
    advise (what, fmt);
}
#endif
